<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly!
}

if ( ! class_exists( 'WPSC_Addons' ) ) :

	final class WPSC_Addons {

		/**
		 * Initialize this class
		 *
		 * @return void
		 */
		public static function init() {}

		/**
		 * List of all supportcandy add-ons
		 *
		 * @return void
		 */
		public static function layout() {
			?>

			<style>
				@import url('https://fonts.googleapis.com/css2?family=Nunito&display=swap');

				body {
					font-family: 'Nunito', sans-serif;
					margin: 0;
				}

				section {
					color: #7a90ff;
					padding: 2em 0;
					min-height: 100%;
					position: relative;
					z-index: 10;
				}

				.pricing {
					display: -webkit-flex;
					display: flex;
					-webkit-flex-wrap: wrap;
					flex-wrap: wrap;
					-webkit-justify-content: center;
					justify-content: center;
					width: 100%;
					margin: 0 auto;
				}

				.pricing-item {
					position: relative;
					display: -webkit-flex;
					display: flex;
					-webkit-flex-direction: column;
					flex-direction: column;
					-webkit-align-items: stretch;
					align-items: stretch;
					text-align: center;
					-webkit-flex: 0 1 330px;
					flex: 0 1 330px;
				}

				.pricing-action {
					color: inherit;
					border: none;
					background: none;
					cursor: pointer;
				}

				.pricing-action:focus {
					outline: none;
				}

				.pricing-feature-list {
					text-align: left;
				}

				.pricing-palden .pricing-item {
					cursor: default;
					color: #84697c;
					background: #fff;
					box-shadow: 0 0 10px rgba(46, 59, 125, 0.23);
					border-radius: 20px 20px 10px 10px;
					margin: 1em;
				}


				@media (min-width: 320px) and (max-width: 768px) {

					.header-title {
						font-size: 3em;
						color: #2C3E50;
						line-height: 1.1em;
					}

					.header-subtitle {
						font-size: 1.5em;
						color: #171717;
						margin: 0px 1em 3em 1em;
					}
				}

				@media (min-width: 769px) and (max-width: 1024px) {

					.header-title {
						font-size: 3em;
						color: #2C3E50;
					}

					.header-subtitle {
						font-size: 1.5em;
						color: #171717;
						margin: 0px 6em 3em 6em;
					}
				}

				@media (min-width: 1025px) and (max-width: 1200px) {

					.header-title {
						font-size: 3em;
						color: #2C3E50;
					}

					.header-subtitle {
						font-size: 1.5em;
						color: #171717;
						margin: 0px 10em 3em 10em;
					}
				}

				@media (min-width: 1201px) {

					.header-title {
						font-size: 3em;
						color: #2C3E50;
					}

					.header-subtitle {
						font-size: 1.5em;
						color: #171717;
						margin: 0px 14em 2em 14em;
					}

					.pricing-palden .pricing-item {
						margin: 1em 2em;
						padding: 0em 1em 2em 1em;
					}

					.pricing-palden .pricing__item--featured {
						margin: 0;
						z-index: 10;
						box-shadow: 0 0 20px rgba(46, 59, 125, 0.23);
					}
				}

				.pricing-palden .pricing-deco {
					border-radius: 10px 10px 0 0;
					padding: 4em 0 1em;
					position: relative;
				}

				.pricing-palden .pricing-deco-img {
					position: absolute;
					bottom: 0;
					left: 0;
					width: 100%;
					height: 160px;
				}

				.pricing-palden .pricing-title {
					font-size: 1.75em;
					margin: 0;
					letter-spacing: 1px;
					color: #45505B;
				}

				.pricing-palden .deco-layer {
					-webkit-transition: -webkit-transform 0.5s;
					transition: transform 0.5s;
				}

				.pricing-palden .pricing-item:hover .deco-layer--1 {
					-webkit-transform: translate3d(15px, 0, 0);
					transform: translate3d(15px, 0, 0);
				}

				.pricing-palden .pricing-item:hover .deco-layer--2 {
					-webkit-transform: translate3d(-15px, 0, 0);
					transform: translate3d(-15px, 0, 0);
				}

				.pricing-palden .icon {
					font-size: 2.5em;
				}

				.pricing-palden .pricing-price {
					font-size: 4em;
					font-weight: bold;
					padding: 0;
					color: #45505B;
					margin: 0.50em 0 0.25em 0;
					line-height: 0.75;
				}

				.pricing-palden .pricing-currency {
					font-size: calc(35em/100);
					vertical-align: top;
				}

				.pricing-palden .pricing-period {
					font-size: 0.25em;
					padding: 0 0 0 0.5em;
					color: #45505BCC;
					letter-spacing: 1px;
				}

				.pricing-palden .pricing__sentence {
					font-weight: bold;
					margin: 0 0 1em 0;
					padding: 0 0 0.5em;
				}

				.pricing-palden .pricing-feature-list {
					margin: 0;
					padding: 1em 0 0em;
					list-style: none;
					text-align: center;
				}

				.pricing-palden .pricing-feature {
					padding: 0.30em 0;
					font-size: 1.2em;
					color: #45505B;
				}

				.pricing-palden .pricing-action {
					font-family: "Nunito", Sans-serif;
					font-size: 20px;
					font-weight: 700;
					margin: auto;
					padding: 0.60em 1em;
					color: #fff;
					border-radius: 5px;
					background: #45505B;
					text-decoration: none;
				}

				.pricing-palden .pricing-item--featured .pricing-deco {
					padding: 5em 0 8.885em 0;
				}

				.header {
					position: relative;
					text-align: center;
					color: white;
				}

				.inner-header {
					height: 100%;
					width: 100%;
					margin: 0;
					padding: 0;
				}

				.flex {
					/*Flexbox for containers*/
					justify-content: center;
					align-items: center;
					text-align: center;
				}

				.waves {
					position: relative;
					width: 100%;
					height: 150vh;
					margin-bottom: -7px;
					/*Fix for safari gap*/
					min-height: 100px;
					max-height: 250px;
				}

				/* Animation */
				.parallax>use {
					animation: move-forever 25s cubic-bezier(.55, .5, .45, .5) infinite;
				}

				.parallax>use:nth-child(1) {
					animation-delay: -2s;
					animation-duration: 7s;
				}

				.parallax>use:nth-child(2) {
					animation-delay: -3s;
					animation-duration: 10s;
				}

				.parallax>use:nth-child(3) {
					animation-delay: -4s;
					animation-duration: 13s;
				}

				.parallax>use:nth-child(4) {
					animation-delay: -5s;
					animation-duration: 20s;
				}

				@keyframes move-forever {
					0% {
						transform: translate3d(-90px, 0, 0);
					}

					100% {
						transform: translate3d(85px, 0, 0);
					}
				}

				/* Toggle menu starts */
				.toggle-menu{
					display: inline-flex;
					justify-content: center;
					align-items: center;
					column-gap: 10px;
				}

				.toggle-title {
					font-size: 1.3em;
					color: #171717;
				}

				#toggle_price{
					background:#f6781e;
					width:70px;
					border-radius:50px;
					border:none;
					height:30px;
					margin: 0px auto;
					cursor:pointer;
				}

				button:focus{
					outline:none;
				}

				.toggle_circle{
					background:#fff;
					width:25.5px;
					height:25.5px;
					border-radius:100%;
					transition:0.2s;
					position:relative;
					left:-3px;
					top:0px;
				}

				.yearly {
					margin-top: 30px;
					display: flex;
				}

				.lifetime {
					margin-top: 30px;
					display: none;
				}

				.toggle_activeated {
					transition:0.2s;
					left:35px;
				}

				.hide_yearly {
					display: none;
				}

				.display_lifetime {
					display: flex;
				}
				/* Toggle menu ends */
			</style>

			<body>
				<div class="header">
					<div class="inner-header flex">
						<section>
							<h1 class="header-title">Simple, straight forward pricing.</h1>
							<p class="header-subtitle">We believe in providing honest and fair pricing. Purchase in confidence with our 30-day money-back guarantee.</p>

							<!-- Toggle starts -->
							<div class="toggle-menu">
								<span class="toggle-title">Yearly</span>
								<button id="toggle_price">
									<div class="toggle_circle"></div>
								</button>
								<span class="toggle-title">Lifetime</span>
							</div>
							<!-- Toggle ends -->

							<div class="yearly pricing pricing-palden">
								<div class="pricing-item features-item ja-animate" data-animation="move-from-bottom" data-delay="item-0" style="min-height: 497px;">
									<div class="pricing-deco">
										<h3 class="pricing-title">Personal</h3>
										<div class="pricing-price">
											<span class="pricing-currency">$</span>79
											<p class="pricing-period">Billed yearly, until cancelled</p>
										</div>
									</div>
									<ul class="pricing-feature-list">
										<li class="pricing-feature">1 Site License</li>
										<li class="pricing-feature">1 Year Plugin Updates</li>
										<li class="pricing-feature">1 Year Priority Support</li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/extensions/"> All Extensions Included </a></li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/integrations/"> All Integrations Included </a></li>
									</ul>
									<a target="_blank" href="https://supportcandy.net/checkout/?edd_action=add_to_cart&download_id=316963" class="pricing-action">Buy Now</a>
								</div>
								<div class="pricing-item features-item ja-animate pricing__item--featured" data-animation="move-from-bottom" data-delay="item-1" style="min-height: 497px;">
									<div class="pricing-deco">
										<h3 class="pricing-title">Professional</h3>
										<div class="pricing-price">
											<span class="pricing-currency">$</span>149
											<p class="pricing-period">Billed yearly, until cancelled</p>
										</div>
									</div>
									<ul class="pricing-feature-list">
										<li class="pricing-feature">5 Site License</li>
										<li class="pricing-feature">1 Year Plugin Updates</li>
										<li class="pricing-feature">1 Year Priority Support</li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/extensions/"> All Extensions Included </a></li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/integrations/"> All Integrations Included </a></li>
									</ul>
									<a target="_blank" href="https://supportcandy.net/checkout/?edd_action=add_to_cart&download_id=316965" class="pricing-action">Buy Now</a>
								</div>
								<div class="pricing-item features-item ja-animate" data-animation="move-from-bottom" data-delay="item-2" style="min-height: 497px;">
									<div class="pricing-deco">
										<h3 class="pricing-title">Agency</h3>
										<div class="pricing-price">
											<span class="pricing-currency">$</span>299
											<p class="pricing-period">Billed yearly, until cancelled</p>
										</div>
									</div>
									<ul class="pricing-feature-list">
										<li class="pricing-feature">20 Site License</li>
										<li class="pricing-feature">1 Year Plugin Updates</li>
										<li class="pricing-feature">1 Year Priority Support</li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/extensions/"> All Extensions Included </a></li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/integrations/"> All Integrations Included </a></li>
									</ul>
									<a target="_blank" href="https://supportcandy.net/checkout/?edd_action=add_to_cart&download_id=316967" class="pricing-action">Buy Now</a>
								</div>
							</div>
							<div class="lifetime pricing pricing-palden">
								<div class="pricing-item features-item ja-animate" data-animation="move-from-bottom" data-delay="item-0" style="min-height: 497px;">
									<div class="pricing-deco">
										<h3 class="pricing-title">Personal</h3>
										<div class="pricing-price">
											<span class="pricing-currency">$</span>199
										</div>
									</div>
									<ul class="pricing-feature-list">
										<li class="pricing-feature">1 Site License</li>
										<li class="pricing-feature">Lifetime Plugin Updates</li>
										<li class="pricing-feature">Lifetime Priority Support</li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/extensions/"> All Extensions Included </a></li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/integrations/"> All Integrations Included </a></li>
									</ul>
									<a target="_blank" href="https://supportcandy.net/checkout/?edd_action=add_to_cart&download_id=321273" class="pricing-action">Buy Now</a>
								</div>
								<div class="pricing-item features-item ja-animate pricing__item--featured" data-animation="move-from-bottom" data-delay="item-1" style="min-height: 497px;">
									<div class="pricing-deco">
										<h3 class="pricing-title">Professional</h3>
										<div class="pricing-price">
											<span class="pricing-currency">$</span>399
										</div>
									</div>
									<ul class="pricing-feature-list">
										<li class="pricing-feature">5 Site License</li>
										<li class="pricing-feature">Lifetime Plugin Updates</li>
										<li class="pricing-feature">Lifetime Priority Support</li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/extensions/"> All Extensions Included </a></li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/integrations/"> All Integrations Included </a></li>
									</ul>
									<a target="_blank" href="https://supportcandy.net/checkout/?edd_action=add_to_cart&download_id=321277" class="pricing-action">Buy Now</a>
								</div>
								<div class="pricing-item features-item ja-animate" data-animation="move-from-bottom" data-delay="item-2" style="min-height: 497px;">
									<div class="pricing-deco">
										<h3 class="pricing-title">Agency</h3>
										<div class="pricing-price">
											<span class="pricing-currency">$</span>799
										</div>
									</div>
									<ul class="pricing-feature-list">
										<li class="pricing-feature">20 Site License</li>
										<li class="pricing-feature">Lifetime Plugin Updates</li>
										<li class="pricing-feature">Lifetime Priority Support</li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/extensions/"> All Extensions Included </a></li>
										<li class="pricing-feature"><a target="_blank" href="https://supportcandy.net/integrations/"> All Integrations Included </a></li>
									</ul>
									<a target="_blank" href="https://supportcandy.net/checkout/?edd_action=add_to_cart&download_id=321279" class="pricing-action">Buy Now</a>
								</div>
							</div>
						</section>
					</div>
				</div>
			</body>
			<script>
				jQuery('#toggle_price').on('click', function(){
					jQuery(".toggle_circle").toggleClass('toggle_activeated');
					jQuery(".yearly").toggleClass('hide_yearly');
					jQuery(".lifetime").toggleClass('display_lifetime');
				});
			</script>
			<?php
		}
	}
endif;

WPSC_Addons::init();
